#pragma once

void mufs_del_tree(struct mufs_tree *tree);
int mufs_lookup_page(struct mufs_tree *tree, uint32_t *page,
	uint32_t va);
int mufs_map_page(struct mufs_tree *tree, uint32_t va, uint32_t page);
void mufs_unmap_page(struct mufs_tree *tree, uint32_t va);
int mufs_alloc_page(struct mufs_tree *tree, uint32_t *page,
	uint32_t va);
void mufs_free_page(struct mufs_tree *tree, uint32_t va);
int mufs_extend_tree(struct mufs_tree *tree, uint8_t depth);
int mufs_shrink_tree(struct mufs_tree *tree, uint32_t max_size);
size_t mufs_tree_read(struct mufs_tree *tree, void *data, uint32_t va,
	size_t len);
size_t mufs_tree_write(struct mufs_tree *tree, void *data, uint32_t va,
	size_t len);
int mufs_sync_tree(struct mufs_tree *tree);
